//
//  ActivityLog.m
//  Solscape
//
//  Created by John Schilling on 11/16/04.
//  Copyright 2004 John Schilling. All rights reserved.
//

#import "ActivityLog.h"
#import "AppController.h"

@implementation ActivityLog

- (id)init
{
    self = [super init];
    if (self) {

    }
    return self;
}


- (void)awakeFromNib
{    
    if (![[self window] setFrameUsingName:@"ActivityLogWindow"]) {
        [[self window] center];
    }
}


- (BOOL)windowShouldClose:(id)sender
{
    return YES;
}

- (void)saveWindowFrame
{
    [[self window] saveFrameUsingName:@"ActivityLogWindow"];
}

- (void)dealloc
{

    [super dealloc];
}







- (IBAction)openLogWindow:(id)sender
{
    [[self window] makeKeyAndOrderFront:self];
    [[self window] display];
}

- (void)addMessageToLog:(NSString *)message
{
    NSMutableAttributedString *atrMessage = [[[NSMutableAttributedString alloc] init] autorelease];
    NSString *time = [[NSCalendarDate calendarDate] descriptionWithCalendarFormat:@"%Y/%m/%d %I:%M%p"];

    [atrMessage appendAttributedString:[[[NSAttributedString alloc] 
            initWithString:[NSString stringWithFormat:@"[%@] %@", time, message] 
            attributes:[NSDictionary dictionaryWithObjectsAndKeys:
                [NSFont fontWithName:@"Geneva" size:9.0], NSFontAttributeName, [NSColor blackColor], NSForegroundColorAttributeName, nil]] autorelease]];
    
    if( [[_logField textStorage] length] > 0 ) [[_logField textStorage] appendAttributedString:[[[NSAttributedString alloc] initWithString:@"\n"] autorelease]];
    [[_logField textStorage] appendAttributedString:atrMessage];
    [_logField setSelectedRange:NSMakeRange( [[_logField textStorage] length], 0 )];
    [_logField scrollRangeToVisible:NSMakeRange( [[_logField textStorage] length], 0 )];
}

- (void)addErrorToLog:(NSString *)error
{
    if ([SharedController beepOnErrors]) NSBeep();
    NSMutableAttributedString *atrError = [[[NSMutableAttributedString alloc] init] autorelease];
    NSString *time = [[NSCalendarDate calendarDate] descriptionWithCalendarFormat:@"%Y/%m/%d %I:%M%p"];

    [atrError appendAttributedString:[[[NSAttributedString alloc] 
                initWithString:[NSString stringWithFormat:@"[%@] %@", time, error] 
                attributes:[NSDictionary dictionaryWithObjectsAndKeys:
                    [NSFont fontWithName:@"Geneva" size:9.0], NSFontAttributeName, [NSColor redColor], NSForegroundColorAttributeName, nil]] autorelease]];
    
    if( [[_logField textStorage] length] > 0 ) [[_logField textStorage] appendAttributedString:[[[NSAttributedString alloc] initWithString:@"\n"] autorelease]];
    [[_logField textStorage] appendAttributedString:atrError];
    [_logField setSelectedRange:NSMakeRange( [[_logField textStorage] length], 0 )];
    [_logField scrollRangeToVisible:NSMakeRange( [[_logField textStorage] length], 0 )];
}

- (IBAction)clearLog:(id)sender
{
    [[_logField textStorage] setAttributedString:[[[NSAttributedString alloc] initWithString:[NSString stringWithFormat:@""]] autorelease]];
}

@end
