//
//  Domain.m
//  OutlineMe
//
//  Created by John Schilling on 11/11/04.
//  Copyright 2004 John Schilling. All rights reserved.
//

#import "Domain.h"


@implementation Domain

- (id)init
{
    self = [super init];
    if (self) {
        nodes = [[NSMutableArray alloc] init];
    }
    return self;
}

- (void)setDomainName:(NSString *)name
{
    [name retain];
    [domainName release];
    domainName = name;
}

- (NSString *)itemName
{
    return domainName;
}

- (NSString *)itemStatus
{
    /* Groups dont have status messages */
    return @"";
}

- (BOOL)isNode
{
    return NO;
}

- (void)addNode:(Node *)newNode
{
    [nodes addObject:newNode];
}

- (Node *)childAtIndex:(int)i
{
    return [nodes objectAtIndex:i];
}

- (int)childrenCount
{
    return [nodes count];
}

- (BOOL)expandable
{
    return ([nodes count] > 0);
}

- (void)dealloc
{
    [nodes removeAllObjects];
    [nodes release];
    [domainName release];
    [super dealloc];
}

@end
