//
//  ImageWindow.h
//  Solscape
//
//  Created by John Schilling on 12/9/04.
//  Copyright 2004 John Schilling. All rights reserved.
//

#import <Cocoa/Cocoa.h>
#import "Node.h"
#import "ImageWindow.h"

@interface ImageController : NSWindowController {

        id                          _delegate;
        
        ImageWindow                 *_imageWindow;
        IBOutlet NSImageView        *_imageView;
        
        NSString                    *_path;
        NSString                    *_name;
        NSString                    *_URL;
        Node                        *_node;
        
        float                       _dwidth;
        float                       _dheight;
        float                       _titleBarHeight;
        float                       _bottomBarHeight;
        
}

- (id)initWithImagePath:(NSString *)path 
                   name:(NSString *)name
                   URL:(NSString *)URL
                  node:(Node *)node
              delegate:(id)delegate;
                                      
- (void)setWindowFrameAttributes;                   
- (NSImage *)getScaledImageFromFileAtPath:(NSString *)filePath;
- (void)cleanup;
- (NSString *)path;
- (NSString *)name;
- (NSString *)URL;
- (Node *)node;

- (void)updateWithOpen:(BOOL)open;

- (IBAction)viewAtDefaultSize:(id)sender;
- (IBAction)viewAtMinSize:(id)sender;
- (IBAction)viewAtMaxSize:(id)sender;
- (IBAction)zoomIn:(id)sender;
- (IBAction)zoomOut:(id)sender;
- (IBAction)miniaturizeWindow:(id)sender;
- (IBAction)centerWindow:(id)sender;
- (void)zoomToNewSize:(NSSize)newSize animate:(BOOL)animate;

- (IBAction)saveDocument:(id)sender;

@end

@interface NSWindowController (ImageControllerDelegate)
- (void)imageWindowDidExit:(ImageController *)ic;
@end


