//
//  MoonView.h
//  Solscape
//
//  Created by John Schilling on 11/18/04.
//  Copyright 2004 John Schilling. All rights reserved.
//

#import <Cocoa/Cocoa.h>


@interface MoonView : NSView {

        NSCalendarDate              *_date;
        NSTimer                     *_timer;
        
        BOOL                        _isOnToday;
        
        IBOutlet NSImageView        *_imageView;
        IBOutlet NSTextField        *_dateField;
        IBOutlet NSTextField        *_phasePercentField;
        IBOutlet NSTextField        *_fullnessPercentField;
        IBOutlet NSTextField        *_daysUntilFullField;
        IBOutlet NSTextField        *_daysUntilNewField;
        
}

- (void)loadFrameSize;
- (void)saveFrameSize;
- (void)cleanup;

- (IBAction)nextMoonDate:(id)sender;
- (IBAction)previousMoonDate:(id)sender;
- (IBAction)todayMoonDate:(id)sender;

- (void)updateDisplayForDate:(NSCalendarDate *)anyDate;
- (int)daysUntilFullMoon:(NSCalendarDate *)anyDate;
- (int)daysUntilNewMoon:(NSCalendarDate *)anyDate;
- (double)moonPhasePercent:(NSCalendarDate *)anyDate;
- (double)moonFullness:(NSCalendarDate *)anyDate;

- (double)getPrec:(double)val prec:(double)prec;
- (NSString *)getMoonPhaseName:(double)phase;
- (int)getMoonPhasePictureInteger:(double)phase;

@end
